
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert       = "XO";
extern bool   EcnBroker         = true;
extern bool   UseAutoMagic      = false;
extern int    ManualMagic       = 111;  
extern double lStopLoss         = 60;
extern double sStopLoss         = 60;
extern double lTakeProfit       = 300;
extern double sTakeProfit       = 300;
extern double lTrailingStop     = 0;
extern double sTrailingStop     = 0;
extern int    Slippage          = 4;
extern double Lots              = 0.1;
extern double MaximumRisk       = 0;
extern double DecreaseFactor    = 3;

extern double BoxSize           = 6.5;
extern int    xoBars            = 1;

extern bool   UseXOClose        = false;
extern double cl_BoxSize        = 6.5;
extern int    cl_xoBars         = 1;

extern bool   UseHourTrade      = false;
extern int    FromHourTrade     = 8;
extern int    ToHourTrade       = 19;

extern string __fricl           = "Setting for friday positions close";
extern bool   CloseOnFriday     = false;
extern int    FridayCloseHour   = 21; // will be used only if CloseOnFriday == true
extern int    FridayCloseMinute = 59; // will be used only if CloseOnFriday == true

extern bool   ShowAlerts        = true;
extern color  clOpenBuy         = Blue;
extern color  clCloseBuy        = Aqua;
extern color  clOpenSell        = Red;
extern color  clCloseSell       = Violet;

//
//
//
//
//

string s_symbol;

int    MAGIC;
int    digit;

double point = 1;
bool dummyBool;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  
  digit  = MarketInfo(s_symbol,MODE_DIGITS);
  if (digit==2 || digit==4) point = 1;
  if (digit==3 || digit==5) point = 10;
  if (digit==6)             point = 100;
  
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (!IsTradeAllowed()) return(0);
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!(Hour() >= FromHourTrade && Hour() <= ToHourTrade)) 
     { Comment("Non-Trading Hours!");  return(0);  }
   }
   else Comment("Trading Hours");
   
   
   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   dummyBool = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)      { dummyBool = OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL)     { dummyBool = OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions())
   {
     int trendCurr = iCustom(s_symbol,0,"XO",BoxSize,4,xoBars  );
     int trendPrev = iCustom(s_symbol,0,"XO",BoxSize,4,xoBars+1);
     
     if (trendCurr > 0 && trendPrev < 0)
     {
        if (CanOpen(OP_BUY)) OpenBuy();
        return(0);
     }
     
     if (trendCurr < 0 && trendPrev > 0)
     {
        if (CanOpen(OP_SELL)) OpenSell();
        return(0);
     }

   }
   
   if (lTrailingStop > 0) TrailingPositionsBuy();
   if (sTrailingStop > 0) TrailingPositionsSell();
   if (UseXOClose)        CheckForClose();
return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
   }
return(false);
}
bool CanOpen( int type) {
   bool result=true;
	for (int i=0; i<OrdersHistoryTotal() && result==true; i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
			if (OrderType() == type && OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC)
			   if (iBarShift(s_symbol,0,OrderOpenTime())==0 || iBarShift(s_symbol,0,OrderCloseTime())==0)
				   result=false;
   }
   return(result);
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > lTrailingStop * Point * point) { 
                  if (OrderStopLoss() < Bid - lTrailingStop * Point * point) 
                      ModifyStopLoss(Bid    - lTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > sTrailingStop * Point * point) { 
                  if (OrderStopLoss() > Ask + sTrailingStop * Point * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + sTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(ldStopLoss,digit),OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(Ask-lStopLoss  *Point*point,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(Ask+lTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return; }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         dummyBool = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 
   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(Bid+sStopLoss  *Point*point,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(Bid-sTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return; }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         dummyBool = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
         }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   int cl_trendCurr = iCustom(s_symbol,0,"XO",cl_BoxSize,4,cl_xoBars  );
   int cl_trendPrev = iCustom(s_symbol,0,"XO",cl_BoxSize,4,cl_xoBars+1);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (cl_trendCurr < 0 && cl_trendPrev > 0) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (cl_trendCurr > 0 && cl_trendPrev < 0) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(1999921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(1999922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(1999931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(1999932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(1999941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(1999942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(1999951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(1999961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(1999962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(1999963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(1999964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(1999965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(1999966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(1999967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(1999971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(1999972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(1999973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(1999981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(1999982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(1999983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(1999991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(1999992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(1999993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(1999994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(1999995);
   
return(ManualMagic);
}



